| OrbbecSDK 1.10.18 OrbbecSDK: Software-Development-Kit for Orbbec 3D Cameras

Loading...
Searching...
No Matches
Public Member Functions | Friends | List of all members
ob::FrameSet Class Reference

Define the FrameSet class, which inherits from the Frame class. More...

`#include <Frame.hpp>`

Inheritance diagram for ob::FrameSet:

## Public Member Functions
| FrameSet (std::unique_ptr< FrameImpl > impl)
| FrameSet (Frame &frame)
| ~FrameSet () noexcept override
uint32_t | frameCount ()
| Get the number of frames in the FrameSet.
std::shared_ptr< DepthFrame > | depthFrame ()
| Get the depth frame in the FrameSet.
std::shared_ptr< ColorFrame > | colorFrame ()
| Get the color frame in the FrameSet.
std::shared_ptr< IRFrame > | irFrame ()
| Get the infrared frame in the FrameSet.
std::shared_ptr< PointsFrame > | pointsFrame ()
| Get the point cloud frame in the FrameSet.
std::shared_ptr< Frame > | getFrame (OBFrameType frameType)
| Get a frame of a specific type from the FrameSet.
std::shared_ptr< Frame > | getFrame (int index)
| Get a frame at a specific index from the FrameSet.
Public Member Functions inherited from ob::Frame
| Frame (std::unique_ptr< FrameImpl > impl)
| Frame (Frame &frame)
virtual | ~Frame () noexcept
virtual OBFrameType | type ()
| Get the type of frame.
virtual OBFormat | format ()
| Get the format of the frame.
virtual uint64_t | index ()
| Get the sequence number of the frame.
virtual void * | data ()
| Get the frame data.
virtual uint32_t | dataSize ()
| Get the size of the frame data.
uint64_t | timeStamp ()
| Get the hardware timestamp of the frame in milliseconds.
uint64_t | timeStampUs ()
| Get the hardware timestamp of the frame in microseconds.
uint64_t | systemTimeStamp ()
| Get the system timestamp of the frame in milliseconds.
uint64_t | systemTimeStampUs ()
| Get the system timestamp of the frame in microseconds.
uint64_t | globalTimeStampUs ()
| Get the global timestamp of the frame in microseconds.
void * | metadata ()
| Get the metadata of the frame.
uint32_t | metadataSize ()
| Get the size of the metadata of the frame.
bool | hasMetadata (OBFrameMetadataType type)
| Check if the frame object has metadata of a given type.
int64_t | getMetadataValue (OBFrameMetadataType type)
| Get the metadata value.
std::shared_ptr< StreamProfile > | getStreamProfile ()
| get StreamProfile of the frame
std::shared_ptr< Sensor > | getSensor ()
| get owner sensor of the frame
std::shared_ptr< Device > | getDevice ()
| get owner device of the frame
template<typename T >
bool | is ()
| Check if the runtime type of the frame object is compatible with a given type.
template<typename T >
std::shared_ptr< T > | as ()
| Convert the frame object to a target type.

## Friends
class | Pipeline
class | Filter

## Additional Inherited Members
Protected Attributes inherited from ob::Frame
std::unique_ptr< FrameImpl > | impl_

## Detailed Description

Define the FrameSet class, which inherits from the Frame class.

Definition at line 305 of file Frame.hpp.

## Constructor & Destructor Documentation

## ◆ FrameSet() [1/2]

ob::FrameSet::FrameSet | ( | std::unique_ptr< FrameImpl > | impl | ) |
| explicit

## ◆ FrameSet() [2/2]

ob::FrameSet::FrameSet | ( | Frame & | frame | ) |
| explicit

## ◆ ~FrameSet()

ob::FrameSet::~FrameSet | ( |  | ) |
| override noexcept

## Member Function Documentation

## ◆ frameCount()

uint32_t ob::FrameSet::frameCount | ( |  | ) |

Get the number of frames in the FrameSet.

Returns
  uint32_t The number of frames

## ◆ depthFrame()

std::shared_ptr< DepthFrame > ob::FrameSet::depthFrame | ( |  | ) |

Get the depth frame in the FrameSet.

Returns
  std::shared_ptr<DepthFrame> The depth frame

## ◆ colorFrame()

std::shared_ptr< ColorFrame > ob::FrameSet::colorFrame | ( |  | ) |

Get the color frame in the FrameSet.

Returns
  std::shared_ptr<ColorFrame> The color frame

## ◆ irFrame()

std::shared_ptr< IRFrame > ob::FrameSet::irFrame | ( |  | ) |

Get the infrared frame in the FrameSet.

Returns
  std::shared_ptr<IRFrame> The infrared frame

## ◆ pointsFrame()

std::shared_ptr< PointsFrame > ob::FrameSet::pointsFrame | ( |  | ) |

Get the point cloud frame in the FrameSet.

Returns
  std::shared_ptr<PointsFrame> The point cloud data frame

## ◆ getFrame() [1/2]

std::shared_ptr< Frame > ob::FrameSet::getFrame | ( | OBFrameType | frameType | ) |

Get a frame of a specific type from the FrameSet.

Parameters

  frameType | The type of sensor

Returns
  std::shared_ptr<Frame> The corresponding type of frame

## ◆ getFrame() [2/2]

std::shared_ptr< Frame > ob::FrameSet::getFrame | ( | int | index | ) |

Get a frame at a specific index from the FrameSet.

Parameters

  index | The index of the frame

Returns
  std::shared_ptr<Frame> The frame at the specified index

## Friends And Related Symbol Documentation

## ◆ Pipeline

friend class Pipeline
| friend

Definition at line 366 of file Frame.hpp.

## ◆ Filter

friend class Filter
| friend

Definition at line 367 of file Frame.hpp.

The documentation for this class was generated from the following file:

- E:/Projects/Jenkins/workspace/OrbbecSDK/libobsensor/include/libobsensor/hpp/Frame.hpp